#ifndef __ARM_H__
#define __ARM_H__

#include <debug.h>
#include <stdint.h>
#include <type.h>

/*
 * Operaciones sobre registros de control.
 */

void irqEnable();
void fiqEnable();
void irqDisable();
void fiqDisable();

/**/

void mmu_enable();
void mmu_disable();

/**/

void icache_disable();
void icache_invalidate();

/**/

void tlb_flush();
void tlb_line_flush(uint line);

/**/

void setControlRegister(uint32_t value);
uint32_t getControlRegister();

/**/

void setTranslationTableBase0(uint32_t addr);
void setTranslationTableBase1(uint32_t addr);
void setTranslationTableControl(uint32_t value);
void setDomainAccessControl(uint32_t value);
uint32_t getTranslationTableBase0();
uint32_t getTranslationTableBase1();
uint32_t getTranslationTableControl();
uint32_t getDomainAccessControl();

/**/

uint32_t getDataFaultStatus();
uint32_t getInstructionFaultStatus();
uint32_t getFaultAddress();
uint32_t getInstructionFaultAddress();

/**/

uint32_t getInterruptStatus();

/**/

void dataMemoryBarrier();

/* Debug */

void debugControlRegister(uint32_t ctrl);

#endif /* __ARM_H__ */