#ifndef __AUX_H__
#define __AUX_H__

/*
	BCM2835 - Axiliary Peripherals
*/

#include <stdint.h>

#define aux_peri_reg_address 0x20215000

typedef struct aux_peri_reg {
	
	uint32_t irq_status;
	uint32_t enables;
	
	uint32_t padding_0[14];
	
	struct {
		uint32_t data;
		uint32_t interrupt_enable;
		uint32_t interrupt_identify;
		uint32_t line_control;
		uint32_t modem_control;
		uint32_t line_status;
		uint32_t modem_status;
		uint32_t scratch;
		uint32_t extra_control;
		uint32_t extra_status;
		uint32_t baudrate;	
	} mini_uart;
	
	uint32_t padding_1[5];
	
	struct {
		uint32_t control_0;
		uint32_t control_1;
		uint32_t status;
		uint32_t padding_2;
		uint32_t data;
		uint32_t peek;
	} spi_0;
	
	uint32_t padding_3[1];
	
	struct {
		uint32_t control_0;
		uint32_t control_1;
		uint32_t status;
		uint32_t padding_4;
		uint32_t data;
		uint32_t peek;
	} spi_1;
	
} aux_peri_reg;

#endif /* __AUX_H__ */
