#ifndef __CBUFFER_H__
#define __CBUFFER_H__

#include <libc.h>

/*
	Buffer circular
*/

typedef struct cbuffer_t cbuffer_t;

struct cbuffer_t
{
	char *data;
	int size;
	int start, end;
};

cbuffer_t* cbuffer_create(int size);
void cbuffer_destroy(cbuffer_t *cb);
int cbuffer_full(cbuffer_t *cb);
int cbuffer_empty(cbuffer_t *cb);
int cbuffer_size(cbuffer_t *cb);
int cbuffer_available(cbuffer_t *cb);
char cbuffer_read(cbuffer_t *cb);
void cbuffer_write(cbuffer_t *cb, char ch);

#endif
