#include <gpio.h>

void gpio_fsel(int pin, int fsel)
{
	GPIO *gpio = (GPIO*) GPIO_CONTROLLER_ADDR;
	
	uint32_t pos = ((pin % 10) * 3);
	
	if(pin < 10)
		gpio->function_select_0 = (gpio->function_select_0 & ~(7 << pos)) | (fsel << pos);
	else if(pin < 20)
		gpio->function_select_1 = (gpio->function_select_1 & ~(7 << pos)) | (fsel << pos);
	else if(pin < 30)
		gpio->function_select_2 = (gpio->function_select_2 & ~(7 << pos)) | (fsel << pos);
}

void gpio_pud(int pin, int pud) {
	GPIO *gpio = (GPIO*) GPIO_CONTROLLER_ADDR;
	
	gpio->pull_up_down_enable = pud & 0x3;
	
	for(int i = 0; i < 150; i++);
	
	if(pin < 32) {
		gpio->pull_up_down_enable_clock_0 = 1 << pin;
		for(int i = 0; i < 150; i++);
		gpio->pull_up_down_enable = 0;
		gpio->pull_up_down_enable_clock_0 = 0;
	}
	else {
		gpio->pull_up_down_enable_clock_1 = 1 << (pin - 32);
		for(int i = 0; i < 150; i++);
		gpio->pull_up_down_enable = 0;
		gpio->pull_up_down_enable_clock_1 = 0;
	}	
}

void gpio_set(int pin)
{
	GPIO *gpio = (GPIO*) GPIO_CONTROLLER_ADDR;
	
	if(pin < 32)
		gpio->output_set_0 = 1 << pin;
}

void gpio_clear(int pin)
{
	GPIO *gpio = (GPIO*) GPIO_CONTROLLER_ADDR;
	
	if(pin < 32)
		gpio->output_clear_0 = 1 << pin;
}

int gpio_read(int pin)
{
	GPIO *gpio = (GPIO*) GPIO_CONTROLLER_ADDR;
	
	if(pin < 32)
		return (gpio->level_0 >> pin) & 1;
	
	return -1;
}
