#include <libc.h>

/*
 * Memory utilities
 */

void* memorySet(void *buffer, int size, char value)
{
	for(int i = 0; i < size; i++)
		((char *) buffer)[i] = value;
	return buffer;
}

void* memoryClear(void *buffer, int size)
{
	return memorySet(buffer, size, 0);
}

void* memoryCopy(void *src, void *dst, int size)
{
	for(int i = 0; i < size; i++)
		((char *) dst)[i] = ((char *) src)[i];
	return dst;
}

/*
 * Kernel malloc/free
 */

void* kmalloc(int size)
{
	return heapAllocateMemory((Heap *) KERNEL_HEAP, size);
}

void kfree(void *address)
{
	heapFreeMemory((Heap *) KERNEL_HEAP, address);
}

/*
 * User malloc/free
 */

void* malloc(int size)
{
	return heapAllocateMemory((Heap *) PROCESS_HEAP, size);
}

void free(void *address)
{
	heapFreeMemory((Heap *) PROCESS_HEAP, address);
}
