#ifndef __LIBC_H__
#define __LIBC_H__

#include <address.h>
#include <heap.h>
#include <stdint.h>

/*
 * Memory utilities
 */

void* memorySet(void *buffer, int size, char value);
void* memoryClear(void *buffer, int size);
void* memoryCopy(void *src, void *dst, int size);

/*
 * map/unmap
 */

#define NA PAGE_RW_NA
#define RO PAGE_RW_RO
#define RW PAGE_RW_RW
#define NON_GLOBAL PAGE_NON_GLOBAL
#define SHARED PAGE_SHARED
#define NOT_EXEC PAGE_NOT_EXEC
#define BUFFERED PAGE_BUFFERED
#define WRITE_BACK PAGE_WR_BACK
#define WRITE_THROUGH PAGE_WR_THROUGH

// int map(uint virt_addr, uint size, uint attrs);
// void unmap(uint virt_addr);

/*
 * kmalloc/kfree
 */

void* kmalloc(int size);
void kfree(void *address);

/*
 * malloc/free
 */

void* malloc(int size);
void free(void *address);

#endif /* __LIBC_H__ */
