#include <scheduler.h>

Scheduler scheduler;

/* Priority RR

Este fue el primer intento, ahora no funciona con el sistema actual.
El RR plano no respondia bien con la tarea speaker. Al cortar la ejecución,
la música se escuchaba entrecortada.

void schedulerInit(Task *systemTask)
{
	systemTask->state    = TASK_RUNNING;
	systemTask->quantum   = 1; // Para que ni bien comience la desaloje

	scheduler.running   = systemTask;
	
	for(int i = 0; i < PQUEUE_SIZE; i++)
		scheduler.pQueue[i] = queueCreate();
}

void schedulerAdmitTask(Task *task)
{
	task->state  = TASK_READY;
	task->quantum = TASK_QUANTUM;
	schedulerEnqueue(task);
}

int schedulerIrq()
{
	if(--scheduler.running->quantum < 1)
		return 1;
	return 0;
}

void schedulerEnqueue(Task *task)
{
	int priorityLevel;
	task->state = TASK_READY;
	task->quantum = (task->quantum < QUANTUM_MIN)? QUANTUM_MIN : task->quantum;
	priorityLevel = task->quantum - QUANTUM_MIN;
	enqueue(scheduler.pQueue[priorityLevel-1], task);
}

Task* schedulerDequeue()
{
	for(int i = PQUEUE_SIZE; i > -1; i--)
	{
		if(queueSize(scheduler.pQueue[i]) > 0)
		{
			return dequeue(scheduler.pQueue[i]);
		}
	}

	return 0;
}

void schedule()
{
	Task *next;
	Task *prev = scheduler.running;

	if(prev->state == TASK_RUNNING)
	{
		// Quantum agotado.
		schedulerEnqueue(prev);
	}

	next = schedulerDequeue();

	if(!next)
		printk("[db] SchedulerDequeueError\n\r");

	next->state = TASK_RUNNING;
	scheduler.running = next;

	if(next != prev)
		contextSwitch(prev->tcb, next->tcb);
}

*/

/* Virtual RR */

Vector *active_process;

void scheduler_init(process_t *kernel)
{
	kernel->state = PSTATE_RUN;
	kernel->ticks = 1;

	scheduler.running   = kernel;
	scheduler.ready     = queueCreate();
	scheduler.auxiliary = queueCreate();

	active_process = vectorCreate();
}

void scheduler_admit(process_t *process)
{
	process->state = PSTATE_RDY;
	enqueue(scheduler.ready, process);

	vectorPushBack(active_process, process);
}

void scheduler_block(process_t *process)
{
	process->state = PSTATE_BLK;
}

void scheduler_unblock(process_t *process)
{
	process->state = PSTATE_RDY;
	enqueue(scheduler.auxiliary, process);
}

int scheduler_irq()
{
	if(--scheduler.running->ticks < 1)
		return 1;
	return 0;
}

void schedule()
{
	process_t *prev = scheduler.running;

	switch(prev->state)
	{
		case(PSTATE_RUN):
			// Si no realizó I/O, añadir de nuevo a la cola.
			prev->state = PSTATE_RDY;
			prev->ticks = prev->quantum;
			enqueue(scheduler.ready, prev);
			break;

		case(PSTATE_BLK):
			if(prev->ticks < 10)
				prev->ticks = 10; // min value (Añadir constante)
			break;
	}

	process_t *next = 0;

	if(queueSize(scheduler.auxiliary) > 0)
		// Despachar tarea de la cola auxiliar.
		next = dequeue(scheduler.auxiliary);

	else
		// Despachar tarea de la cola "ready". INV= queueSize(ready) > 0 (Siempre tengo al sistema)
		next = dequeue(scheduler.ready);
	
	next->state = PSTATE_RUN;

	scheduler.running = next;

	//debug("Switch from proc(%d) to proc(%d), %x - %x\n", prev->pid, next->pid, prev->pcb->r14_usr, prev->pcb->r14_svc);

	if(next != prev)
		contextSwitch(prev->pcb, next->pcb);
}

process_t* scheduler_running()
{
	return scheduler.running;
}

/**/

int getpid()
{
	//debug("ask for id %d\n", scheduler.running->pid);
	return scheduler.running->pid;
}
