#ifndef __SCHEDULER_H__
#define __SCHEDULER_H__

#include <sleep.h>
#include <process.h>

/* Priority RR

#define TASK_READY 1
#define TASK_RUNNING 2
#define TASK_BLOCKED 3

#define TASK_QUANTUM 100

#define QUANTUM_MAX 100
#define QUANTUM_MIN 20

#define PQUEUE_SIZE (QUANTUM_MAX - QUANTUM_MIN)

typedef struct Scheduler
{
	Task *running;
	Queue *pQueue[PQUEUE_SIZE];

} Scheduler;

extern Scheduler scheduler;
extern void contextSwitch(TaskControlBlock *ta, TaskControlBlock *tb);

void schedulerInit(Task *systemTask);
void schedulerAdmitTask(Task *task);
int schedulerIrq();
void schedule();
void schedulerEnqueue(Task *task);
Task* schedulerDequeue();

*/

/* Virtual RR */

typedef struct Scheduler
{
	process_t *running;
	Queue *ready;
	Queue *auxiliary;

} Scheduler;

extern Vector *active_process;

extern Scheduler scheduler;
extern void contextSwitch(pcb_t *a, pcb_t *b);

void scheduler_init(process_t *kernel);
void scheduler_admit(process_t *process);
void scheduler_block(process_t *process);
void scheduler_unblock(process_t *process);
int scheduler_irq();
void schedule();

process_t* scheduler_running();

int getpid();

/* Debug */

#endif /* __SCHEDULER_H__ */
