#include <shared.h>

// Añade un página de 4k al proceso actual marcada como compartida.
// Todos los procesos hijos (fork) tendrán la página mapeada en la misma dirección que el padre.

void* shared_create()
{
	process_t *this = scheduler_running();

	segment_t *section = kmalloc(sizeof(segment_t));

	section->virt_addr = PROCESS_SHARED;
	section->offset = SMALL_PAGE_SIZE;
	section->phys_addr = 0;
	section->attr = PAGE_RW_RW | PAGE_NOT_EXEC | PAGE_WR_THROUGH;

	mmu_map_smallpage(this->pcb->ttb, mmap_alloc_user(), section->virt_addr, section->attr);

	this->shared = section;

	return (void *) section->virt_addr;
}
