#include <sleep.h>

DeltaQueue *sleepQueue;

void sleepInit()
{
	sleepQueue = deltaQueueCreate();
}

/* Cuando estaba el RR plano

int sleepIrq()
{
	if(deltaQueueSize(sleepQueue) > 0)
	{
		int scheduleFlag = 0;
		DeltaQueueItem *front;
		Task *task;

		front = deltaQueueFront(sleepQueue);
		front->delta --;

		while(front != 0)
		{
			if(front->delta < 1)
			{
				scheduleFlag = 1;
				task = deltaQueueDequeue(sleepQueue);
				schedulerEnqueue(task);
				front = deltaQueueFront(sleepQueue);
			}
			else
				front = 0;
		}

		if(scheduleFlag)
			return 1;
	}

	return 0;
}

*/

/* Virtual RR */
int sleepIrq()
{
	if(deltaQueueSize(sleepQueue) > 0)
	{
		int scheduleFlag = 0;
		DeltaQueueItem *front;
		process_t *task;

		front = deltaQueueFront(sleepQueue);
		front->delta --;

		while(front != 0)
		{
			if(front->delta < 1)
			{
				scheduleFlag = 1;
				task = deltaQueueDequeue(sleepQueue);
				scheduler_unblock(task);
				front = deltaQueueFront(sleepQueue);
			}
			else
				front = 0;
		}

		if(scheduleFlag)
			return 1;
	}

	return 0;
}

void sleep(int ms)
{
	process_t *running = scheduler_running();
	scheduler_block(running);
	deltaQueueEnqueue(sleepQueue, running, ms);
	schedule();
}

//////////////////////////////////////////////////////////

void sleep2(uint32_t millis) // polling
{
	SystemTimer *timer = (SystemTimer *) SystemTimerAddress;
	uint32_t end = timer->counter_low + millis * 1000;
	while(timer->counter_low < end);
}

void delayMicroseconds(uint32_t micros) // polling, debajo de la resolución de sistema
{
	SystemTimer *timer = (SystemTimer *) SystemTimerAddress;
	uint32_t end = timer->counter_low + micros;
	while(timer->counter_low < end);
}

