#ifndef __SYSCALL_H__
#define __SYSCALL_H__

#include <exec.h>
#include <gpio.h>
#include <sleep.h>
#include <timer.h>
#include <fork.h>
#include <mutex.h>
#include <uart.h>
#include <shared.h>
#include <wait.h>
#include <exit.h>
#include <libc.h>

#define SWI_SIZE 100

#define SWI_GPIO_CLEAR 0
#define SWI_GPIO_SET 1
#define SWI_GPIO_FSEL 2
#define SWI_SLEEP 10
#define SWI_GETPID 35
#define SWI_FORK 40
#define SWI_EXEC 41
#define SWI_WAIT 42
#define SWI_QUIT 43
#define SWI_GETCH 45
#define SWI_PUTCH 46
#define SWI_MUTEX_CREATE 50
#define SWI_MUTEX_ADQUIRE 51
#define SWI_MUTEX_RELEASE 52
#define SWI_SHARED_CREATE 60
#define SWI_MALLOC 70
#define SWI_FREE 71

extern uint32_t swi_table[SWI_SIZE];

#define swi_install(no, swi) swi_table[no] = ((uint32_t) swi);

void swi_init();

#endif /* __SYSCALL_H__ */
