#include <timer.h>

void systemTimerInit()
{
	SystemTimer *timer = (SystemTimer *) SystemTimerAddress;
	IrqController *irq = (IrqController *) IRQ_CONTROLLER_ADDR;
	timer->compare_1 = timer->counter_low + 1000; /* 1 milisegundo */
	timer->control = 0x2;  /* Limpiar el registro comparador no. 1 */
	irq->enable_1.irq.timer_1 = 1; /* Habilitar irq1 (comparador no. 1) */
}

void systemTimerIrq()
{
	SystemTimer *timer = (SystemTimer *) SystemTimerAddress;
	IrqController *irq = (IrqController *) IRQ_CONTROLLER_ADDR;
	
	 /* Verificar irq1 */
	if(irq->pending_1.irq.timer_1)
	{
		timer->compare_1 = timer->counter_low + 1000;
		timer->control = 0x2;
	}
}

uint32_t getSystemTimerCounter()
{
	SystemTimer *timer = (SystemTimer *) SystemTimerAddress;
	return timer->counter_low;
}

