#include <vector.h>

// TODO: verificar rango índices.

Vector* vectorCreate()
{
	Vector *vector = new(sizeof(Vector));
	vector->array = new(sizeof(void *) << 3);
	vector->arraySize = 8;
	vector->size = 0;

	for(int i = 0; i < vector->arraySize; i++)
		vector->array[i] = 0;
	
	return vector;
}

void vectorDestroy(Vector *vector)
{
	delete(vector->array);
	delete(vector);
}

int vectorSize(Vector *vector)
{
	return vector->size;
}

bool vectorEmpty(Vector *vector)
{
	return ((vector->size > 0)? true : false);
}

void* vectorAt(Vector *vector, int index)
{
	return vector->array[index];
}

void vectorPushBack(Vector *vector, void *data)
{
	if((vector->size + 1) > vector->arraySize)
		vectorExpandArray(vector);

	vector->array[vector->size++] = data;
}

void vectorPushFront(Vector *vector, void *data)
{
	if((vector->size + 1) > vector->arraySize)
		vectorExpandArray(vector);

	for(int i = vector->size; i > 0; i--)
		vector->array[i] = vector->array[i-1];

	vector->array[0] = data;
	vector->size++;
}

// Inserta el elemento en el índice "index" desplazando los elementos que le siguen

void vectorInsert(Vector *vector, void *data, int index)
{
	if((vector->size + 1) > vector->arraySize)
		vectorExpandArray(vector);

	for(int i = vector->size; i != index; i--)
		vector->array[i] = vector->array[i-1];

	vector->array[index] = data;
	vector->size++;
}

void* vectorPopBack(Vector *vector)
{
	return vector->array[--vector->size];
}

void* vectorPopFront(Vector *vector)
{
	void *data = vector->array[0];
	for(int i = 0; i < vector->size; i++)
		vector->array[i] = vector->array[i+1];
	vector->size--;
	return data;
}

void* vectorRemove(Vector *vector, int index)
{
	void *data = vector->array[index];
	for(int i = index; i < vector->size; i++)
		vector->array[i] = vector->array[i+1];
	vector->size--;
	return data;
}

void vectorExpandArray(Vector *vector)
{
	int newArraySize = vector->arraySize << 1;
	void **newArray = new(sizeof(void*) * newArraySize);

	for(int i = 0; i < newArraySize; i++)
	{
		if(i < vector->arraySize)
			newArray[i] = vector->array[i];
		else
			newArray[i] = 0;
	}

	delete(vector->array);

	vector->array = newArray;
	vector->arraySize = newArraySize;
}

