#ifndef __VECTOR_H__
#define __VECTOR_H__

#include <libc.h>

#define new(x) kmalloc(x)
#define delete(x) kfree(x)

typedef struct Vector Vector;

struct Vector
{
	void **array;
	int arraySize;
	int size;
};

Vector* vectorCreate();
void vectorDestroy(Vector *vector);
void vectorPushBack(Vector *vector, void *data);
void vectorPushFront(Vector *vector, void *data);
void vectorInsert(Vector *vector, void *data, int index);
void* vectorPopBack(Vector *vector);
void* vectorPopFront(Vector *vector);
void* vectorRemove(Vector *vector, int index);
int vectorSize(Vector *vector);
void* vectorAt(Vector *vector, int index);
void vectorExpandArray(Vector *vector);

#endif /* __VECTOR_H__ */
